# -*- coding: utf-8 -*-
from setuphelpers import *


def install():
    # Declaring local variables
    package_version = control.get_software_version()
    bin_name = glob.glob("*_win64*.exe")[0]

    # Uninstalling older major versions of the software
    for to_uninstall in installed_softwares(name=r"Avidemux"):
        if Version(to_uninstall["version"], 2) < Version(package_version, 2) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(control.impacted_process.split(","))
            cmd = to_uninstall["uninstall_string"]
            run(f'"{cmd}" /S')
            wait_uninstallkey_absent(to_uninstall["key"])

    # Installing the software
    print("Installing: %s" % bin_name)
    install_exe_if_needed(
        bin_name,
        silentflags="/S",
        name="Avidemux",
        min_version=package_version,
        accept_returncodes=[0, 1223],
    )
    # Avoiding the usage by WAPT of the app built-in Uninstallstring
    uninstallkey.clear()


def uninstall():
    for to_uninstall in installed_softwares(name=r"Avidemux"):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(control.impacted_process.split(","))

        cmd = to_uninstall["uninstall_string"]
        run(f'"{cmd}" /S')
        wait_uninstallkey_absent(to_uninstall["key"])
